#!/usr/bin/python
# coding: UTF-8

##########################################################################
# 用来从 weather.com 获得信息并输出到 /tmp/weather.txt 中。若需要改变地  #
# 址（城市），请到 www.weather.com(.cn) 查询你自己的城市，将结果页面的地 #
# 址替换到 URL 变量当中。                                                #
##########################################################################
# By Clarkok                                              ---- 2012.7.23 #
##########################################################################

import	os,	sys

# 获得字符串中的下一个标签
def	get_tag(STR):
	bpos	= STR.find('<')
	if bpos == -1:
		return	''
	else:
		STR	= STR[bpos:]
		return	STR[0:STR.find('>')+1]

# 获得字符串中下一个标签结束之后的东西
def	next_tag(STR):
	pos	= STR.find('>')
	if pos == -1:
		return	''
	else:
		return	STR[pos+1:]

# 获得字符串下一个标签之前的东西
def	before_tag(STR):
	pos	= STR.find('<')
	if pos == -1:
		return	''
	else:
		res	= STR[0:pos];
		return	res.strip()

def	get_day_info(START_STR):
	# 截取数据区域
	part_str	= html[html.find(START_STR)+len(START_STR):]
	part_str	= part_str[part_str.find('<'):]
	t_name		= part_str[0:part_str.find(' ')]
	t_name		= r'</' + t_name[1:] + '>'
	part_str	= part_str[0:part_str.find(t_name)+len(t_name)];

	# 很简单地把在表格中但不在标签中的内容拿出来
	res		= "-"
	while (len(part_str)):
		tag		= get_tag(part_str)
		part_str	= next_tag(part_str)
		if (tag[1:3] == "td"):
			while 1:
				bstr		=  before_tag(part_str);
				if len(bstr) != 0:
					res		+=bstr + '\n'
				tag		=  get_tag(part_str)
				part_str	=  next_tag(part_str)
				if (tag[1:4] == r"/td"):
					break
	return	res

URL		= "http://www.weather.com.cn/weather/101210904.shtml"
TMP_FILE	= "/tmp/weather.html"
OUT_FILE	= "/tmp/weather.txt"

RESULT		= ""

os.system("wget " + URL + " -qO" + TMP_FILE);

if (not os.path.isfile(TMP_FILE)):
	die("Error While Get Infomation")

t_file		= open(TMP_FILE, "r");
html		= t_file.read();
t_file.close()

# 最多有7天，需要自取
ofile		= open(OUT_FILE, "w");
RESULT	=  get_day_info(r"<!--day 1-->") + '\n'
RESULT	+= get_day_info(r"<!--day 2-->") + '\n'
RESULT	+= get_day_info(r"<!--day 3-->") + '\n'

ofile.write(RESULT)
ofile.close()
